#!/usr/bin/perl
# setup.sh
# Calls ssh-keygen for the user

require './ssh-lib.pl';
&ReadParse();
&error_setup($text{'setup_err'});

# Check for openssh version 3.4 or above
$out = `ssh -V 2>&1`;
if ($out =~ /OpenSSH.([0-9\.]+)/i && $1 >= 3.4) {
	$type = "-t rsa1";
	}

$out = `echo '' | ssh-keygen $type -P \"$in{'pass'}\" 2>&1`;
if ($?) {
	&error("<tt>$out</tt>");
	}
system("cp $ssh_directory/identity.pub $ssh_directory/authorized_keys");
&redirect("");

